﻿' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

Imports Windows.Devices.Sensors
Imports Windows.UI.Popups
Imports Windows.UI.Core
Imports Windows.UI


Public NotInheritable Class MainPage
    Inherits Page
    Dim myTimer As DispatcherTimer
    Dim myAccelerometer As Accelerometer
    Dim no As Integer = 0
    'Dim myCoreDispacher As CoreDispatcher
    'Dim xmldoc As XElement
    Dim myCount As Integer = 0
    Dim myValue As AccelerometerReading = Nothing
    Protected Overrides Async Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        myTimer = New DispatcherTimer
        myTimer.Interval = TimeSpan.FromMilliseconds(1000)
        AddHandler myTimer.Tick, AddressOf myTimer_Tick
        myTimer.Start()
        myAccelerometer = Accelerometer.GetDefault
        If myAccelerometer Is Nothing = True Then
            Dim message As New MessageDialog("加速度センサーに対応しておりません。")
            Await message.ShowAsync
            Exit Sub
        Else
            AddHandler myAccelerometer.ReadingChanged, AddressOf myAccelerometer_ReadingChanged
        End If

        Dim myFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim myPictures = Await myFolder.GetFilesAsync
        myCount = myPictures.Count

        If myCount = 0 Then
            Dim message As New MessageDialog("ピクチャライブラリ内に表示する画像がありません。")
            Await message.ShowAsync
            Exit Sub
        End If

        For Each result In myPictures
            Dim bmp As New BitmapImage
            bmp.SetSource(Await result.OpenSequentialReadAsync)
            Dim myImage As New Image
            myImage.Stretch = Stretch.None
            myImage.Source = bmp

            Dim fileNameTextBlock As New TextBlock
            With fileNameTextBlock
                .Padding = New Thickness(5)
                .FontSize = 24
                .Foreground = New SolidColorBrush(Colors.Gold)
                .Text = Path.GetFileName(result.Name)
                .HorizontalAlignment = Xaml.HorizontalAlignment.Center
            End With

            Dim myStackPanel As New StackPanel
            myStackPanel.Children.Add(myImage)
            myStackPanel.Children.Add(fileNameTextBlock)
            FlipView1.Items.Add(myStackPanel)

        Next
        PageTextBlock.Text = (no + 1).ToString & "/" & myCount
    End Sub


    Private Sub myAccelerometer_ReadingChanged(sender As Accelerometer, e As AccelerometerReadingChangedEventArgs)
        myValue = e.Reading
    End Sub

    Private Sub myTimer_Tick(sender As Object, e As Object)

        If myValue Is Nothing = True Then
            Exit Sub
        Else
            If Math.Abs(myValue.AccelerationX) < Math.Abs(myValue.AccelerationY) Then
                Exit Sub
            Else
                If myValue.AccelerationX > 0 Then
                    If no >= myCount - 1 Then
                        no = myCount - 1
                        Exit Sub
                    Else
                        no += 1
                        FlipView1.SelectedIndex = no
                    End If

                Else
                    If no <= 0 Then
                        no = 0
                        Exit Sub
                    Else
                        no -= 1
                        FlipView1.SelectedIndex = no
                    End If
                End If
            End If
        End If
        PageTextBlock.Text = (no + 1).ToString & "/" & myCount
    End Sub

End Class
